#ifndef CHIP_CLK_DEFS_H
#define CHIP_CLK_DEFS_H

#include "chip_std_defs.h"



#define CHIP_CLK_TYPE_IN                    1
#define CHIP_CLK_TYPE_PLL                   2
#define CHIP_CLK_TYPE_SRC_PLL               3
#define CHIP_CLK_TYPE_SRC_EXT               4
#define CHIP_CLK_TYPE_ROOT                  5
#define CHIP_CLK_TYPE_PERIPH                6


#define CHIP_CLK_SLICE_NONE                 0
#define CHIP_CLK_SLICE_CORE                 1  /* 3-bit postdiv, no prediv,    8x2mux, gate */
#define CHIP_CLK_SLICE_BUS                  2  /* 6-bit postdiv, 3-bit prediv, 8x2mux, gate */
#define CHIP_CLK_SLICE_PERIPH               3  /* 6-bit postdiv  3-bit prediv, 8x1mux, gate */


#define CHIP_CLK_ROOT_CORE_POSTDIV_MAX      8
#define CHIP_CLK_ROOT_BUS_POSTDIV_MAX       64
#define CHIP_CLK_ROOT_BUS_PREDIV_MAX        8
#define CHIP_CLK_ROOT_PERIPH_POSTDIV_MAX    64
#define CHIP_CLK_ROOT_PERIPH_PREDIV_MAX     8



#define CHIP_CLK_ID(type, num)              (((type) << 28) | (num))
#define CHIP_CLK_ID_GET_TYPE(clkid)         (((clkid) >> 28) & 0xF)
#define CHIP_CLK_ID_GET_NUM(clkid)          (((clkid) >> 0) & 0xFF)

#define CHIP_CLK_ID_IN(num)                 CHIP_CLK_ID(CHIP_CLK_TYPE_IN, num)
#define CHIP_CLK_ID_PLL(num)                CHIP_CLK_ID(CHIP_CLK_TYPE_PLL, num)
#define CHIP_CLK_ID_ROOT(slice, num)        (CHIP_CLK_ID(CHIP_CLK_TYPE_ROOT, num) | ((slice) << 16))
#define CHIP_CLK_ID_PERIPH(num)             CHIP_CLK_ID(CHIP_CLK_TYPE_PERIPH, num)

#define CHIP_CLK_ID_ROOT_GET_IDX(clkid)     CHIP_CLK_ID_GET_NUM(clkid)
#define CHIP_CLK_ID_ROOT_GET_TYPE(clkid)    (((clkid) >> 16) & 0xF)

#define CHIP_CLK_ID_SRC_PLL(pll_ctrl)       CHIP_CLK_ID(CHIP_CLK_TYPE_SRC_PLL, pll_ctrl)
#define CHIP_CLK_ID_SRC_EXT(num)            CHIP_CLK_ID(CHIP_CLK_TYPE_SRC_EXT, num)

#define CHIP_CLK_CLKIN1_ID                  CHIP_CLK_ID_IN(0)
#define CHIP_CLK_CLKIN2_ID                  CHIP_CLK_ID_IN(1)
#define CHIP_CLK_OSC_24M                    CHIP_CLK_ID_IN(2)
#define CHIP_CLK_OSC_32K                    CHIP_CLK_ID_IN(3)

#define CHIP_CLK_PLL_AUDIO1_ID              CHIP_CLK_ID_PLL(0)
#define CHIP_CLK_PLL_AUDIO2_ID              CHIP_CLK_ID_PLL(1)
#define CHIP_CLK_PLL_VIDEO1_ID              CHIP_CLK_ID_PLL(2)
#define CHIP_CLK_PLL_DRAM_ID                CHIP_CLK_ID_PLL(4)
#define CHIP_CLK_PLL_GPU_ID                 CHIP_CLK_ID_PLL(5)
#define CHIP_CLK_PLL_VPU_ID                 CHIP_CLK_ID_PLL(6)
#define CHIP_CLK_PLL_ARM_ID                 CHIP_CLK_ID_PLL(7)
#define CHIP_CLK_PLL_SYS1_ID                CHIP_CLK_ID_PLL(8)
#define CHIP_CLK_PLL_SYS2_ID                CHIP_CLK_ID_PLL(9)
#define CHIP_CLK_PLL_SYS3_ID                CHIP_CLK_ID_PLL(10)
#define CHIP_CLK_PLL_HSIO                   CHIP_CLK_ID_PLL(11) /* ??? */
#define CHIP_CLK_PLL_SAI                    CHIP_CLK_ID_PLL(12) /* ??? */
#define CHIP_CLK_PLL_AV                     CHIP_CLK_ID_PLL(13) /* ??? */



#define CHIP_CLK_ARM_PLL_ID                 CHIP_CLK_ID_SRC_PLL(12)
#define CHIP_CLK_GPU_PLL_ID                 CHIP_CLK_ID_SRC_PLL(13)
#define CHIP_CLK_VPU_PLL_ID                 CHIP_CLK_ID_SRC_PLL(14)
#define CHIP_CLK_DRAM_PLL_ID                CHIP_CLK_ID_SRC_PLL(15)
#define CHIP_CLK_SYS_PLL1_ID                CHIP_CLK_ID_SRC_PLL(16)
#define CHIP_CLK_SYS_PLL1_DIV2_ID           CHIP_CLK_ID_SRC_PLL(17)
#define CHIP_CLK_SYS_PLL1_DIV3_ID           CHIP_CLK_ID_SRC_PLL(18)
#define CHIP_CLK_SYS_PLL1_DIV4_ID           CHIP_CLK_ID_SRC_PLL(19)
#define CHIP_CLK_SYS_PLL1_DIV5_ID           CHIP_CLK_ID_SRC_PLL(20)
#define CHIP_CLK_SYS_PLL1_DIV6_ID           CHIP_CLK_ID_SRC_PLL(21)
#define CHIP_CLK_SYS_PLL1_DIV8_ID           CHIP_CLK_ID_SRC_PLL(22)
#define CHIP_CLK_SYS_PLL1_DIV10_ID          CHIP_CLK_ID_SRC_PLL(23)
#define CHIP_CLK_SYS_PLL1_DIV20_ID          CHIP_CLK_ID_SRC_PLL(24)
#define CHIP_CLK_SYS_PLL2_ID                CHIP_CLK_ID_SRC_PLL(25)
#define CHIP_CLK_SYS_PLL2_DIV2_ID           CHIP_CLK_ID_SRC_PLL(26)
#define CHIP_CLK_SYS_PLL2_DIV3_ID           CHIP_CLK_ID_SRC_PLL(27)
#define CHIP_CLK_SYS_PLL2_DIV4_ID           CHIP_CLK_ID_SRC_PLL(28)
#define CHIP_CLK_SYS_PLL2_DIV5_ID           CHIP_CLK_ID_SRC_PLL(29)
#define CHIP_CLK_SYS_PLL2_DIV6_ID           CHIP_CLK_ID_SRC_PLL(30)
#define CHIP_CLK_SYS_PLL2_DIV8_ID           CHIP_CLK_ID_SRC_PLL(31)
#define CHIP_CLK_SYS_PLL2_DIV10_ID          CHIP_CLK_ID_SRC_PLL(32)
#define CHIP_CLK_SYS_PLL2_DIV20_ID          CHIP_CLK_ID_SRC_PLL(33)
#define CHIP_CLK_SYS_PLL3_ID                CHIP_CLK_ID_SRC_PLL(34)
#define CHIP_CLK_AUDIO_PLL1_ID              CHIP_CLK_ID_SRC_PLL(35)
#define CHIP_CLK_AUDIO_PLL2_ID              CHIP_CLK_ID_SRC_PLL(36)
#define CHIP_CLK_VIDEO_PLL_ID               CHIP_CLK_ID_SRC_PLL(37)

#define CHIP_CLK_32K_REF_ID                 CHIP_CLK_ID_SRC_EXT(0) /* 32K oscillator clock output */
#define CHIP_CLK_24M_REF_ID                 CHIP_CLK_ID_SRC_EXT(1) /* 24M oscillator clock output */
#define CHIP_CLK_EXT_CLK1_ID                CHIP_CLK_ID_SRC_EXT(2) /* Clock input from external IO */
#define CHIP_CLK_EXT_CLK2_ID                CHIP_CLK_ID_SRC_EXT(3) /* Clock input from external IO */
#define CHIP_CLK_EXT_CLK3_ID                CHIP_CLK_ID_SRC_EXT(4) /* Clock input from external IO */
#define CHIP_CLK_EXT_CLK4_ID                CHIP_CLK_ID_SRC_EXT(5) /* Clock input from external IO */




#define CHIP_CLK_MISC_MNIT_ID               /* ??? */







#define CHIP_CLK_ROOT_ARM_A53_ID            CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_CORE,   0)
#define CHIP_CLK_ROOT_ARM_M7_ID             CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_CORE,   1)
#define CHIP_CLK_ROOT_ML_ID                 CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_CORE,   2)
#define CHIP_CLK_ROOT_GPU3D_CORE_ID         CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_CORE,   3)
#define CHIP_CLK_ROOT_GPU3D_SHADER_ID       CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_CORE,   4)
#define CHIP_CLK_ROOT_GPU2D_ID              CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_CORE,   5)
#define CHIP_CLK_ROOT_AUDIO_AXI_ID          CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_CORE,   6)
#define CHIP_CLK_ROOT_HSIO_AXI_ID           CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_CORE,   7)
#define CHIP_CLK_ROOT_MEDIA_ISP_ID          CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_CORE,   8)
#define CHIP_CLK_ROOT_MAIN_AXI_ID           CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_BUS,    16)
#define CHIP_CLK_ROOT_ENET_AXI_ID           CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_BUS,    17)
#define CHIP_CLK_ROOT_NAND_USDHC_BUS_ID     CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_BUS,    18)
#define CHIP_CLK_ROOT_VPU_BUS_ID            CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_BUS,    19)
#define CHIP_CLK_ROOT_MEDIA_AXI_ID          CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_BUS,    20)
#define CHIP_CLK_ROOT_MEDIA_APB_ID          CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_BUS,    21)
#define CHIP_CLK_ROOT_HDMI_APB_ID           CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_BUS,    22)
#define CHIP_CLK_ROOT_HDMI_AXI_ID           CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_BUS,    23)
#define CHIP_CLK_ROOT_GPU_AXI_ID            CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_BUS,    24)
#define CHIP_CLK_ROOT_GPU_AHB_ID            CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_BUS,    25)
#define CHIP_CLK_ROOT_NOC_ID                CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_BUS,    26) /* ?? */
#define CHIP_CLK_ROOT_NOC_IO_ID             CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_BUS,    27) /* ?? */
#define CHIP_CLK_ROOT_ML_AXI_ID             CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_BUS,    28)
#define CHIP_CLK_ROOT_ML_AHB_ID             CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_BUS,    29)
#define CHIP_CLK_ROOT_AHB_ID                CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_BUS,    32)
#define CHIP_CLK_ROOT_IPG_ID                CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_BUS,    33)
#define CHIP_CLK_ROOT_AUDIO_AHB_ID          CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_BUS,    34)
#define CHIP_CLK_ROOT_MEDIA_DISP2_ID        CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_BUS,    38)
#define CHIP_CLK_ROOT_DRAM_SEL_ID           CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_NONE,   48)
#define CHIP_CLK_ROOT_ARM_A53_SEL_ID        CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_NONE,   49)
#define CHIP_CLK_ROOT_DRAM_ALT_ID           CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 64)
#define CHIP_CLK_ROOT_DRAM_APB_ID           CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 65)
#define CHIP_CLK_ROOT_VPU_G1_ID             CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 66)
#define CHIP_CLK_ROOT_VPU_G2_ID             CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 67)
#define CHIP_CLK_ROOT_CAN1_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 68)
#define CHIP_CLK_ROOT_CAN2_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 69)
#define CHIP_CLK_ROOT_MEMREPAIR_ID          CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 70)
#define CHIP_CLK_ROOT_PCIE_PHY_ID           CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 71)
#define CHIP_CLK_ROOT_PCIE_AUX_ID           CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 72)
#define CHIP_CLK_ROOT_I2C5_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 73)
#define CHIP_CLK_ROOT_I2C6_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 74)
#define CHIP_CLK_ROOT_SAI1_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 75)
#define CHIP_CLK_ROOT_SAI2_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 76)
#define CHIP_CLK_ROOT_SAI3_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 77)
#define CHIP_CLK_ROOT_SAI5_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 79)
#define CHIP_CLK_ROOT_SAI6_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 80)
#define CHIP_CLK_ROOT_ENET_QOS_ID           CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 81)
#define CHIP_CLK_ROOT_ENET_QOS_TIMER_ID     CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 82)
#define CHIP_CLK_ROOT_ENET_REF_ID           CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 83)
#define CHIP_CLK_ROOT_ENET_TIMER_ID         CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 84)
#define CHIP_CLK_ROOT_ENET_PHY_REF_ID       CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 85)
#define CHIP_CLK_ROOT_NAND_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 86)
#define CHIP_CLK_ROOT_QSPI_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 87)
#define CHIP_CLK_ROOT_USDHC1_ID             CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 88)
#define CHIP_CLK_ROOT_USDHC2_ID             CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 89)
#define CHIP_CLK_ROOT_I2C1_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 90)
#define CHIP_CLK_ROOT_I2C2_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 91)
#define CHIP_CLK_ROOT_I2C3_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 92)
#define CHIP_CLK_ROOT_I2C4_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 93)
#define CHIP_CLK_ROOT_UART1_ID              CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 94)
#define CHIP_CLK_ROOT_UART2_ID              CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 95)
#define CHIP_CLK_ROOT_UART3_ID              CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 96)
#define CHIP_CLK_ROOT_UART4_ID              CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 97)
#define CHIP_CLK_ROOT_GIC_ID                CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 100)
#define CHIP_CLK_ROOT_ECSPI1_ID             CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 101)
#define CHIP_CLK_ROOT_ECSPI2_ID             CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 102)
#define CHIP_CLK_ROOT_PWM1_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 103)
#define CHIP_CLK_ROOT_PWM2_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 104)
#define CHIP_CLK_ROOT_PWM3_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 105)
#define CHIP_CLK_ROOT_PWM4_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 106)
#define CHIP_CLK_ROOT_GPT1_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 107)
#define CHIP_CLK_ROOT_GPT2_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 108)
#define CHIP_CLK_ROOT_GPT3_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 109)
#define CHIP_CLK_ROOT_GPT4_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 110)
#define CHIP_CLK_ROOT_GPT5_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 111)
#define CHIP_CLK_ROOT_GPT6_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 112)
#define CHIP_CLK_ROOT_TRACE_ID              CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 113)
#define CHIP_CLK_ROOT_WDOG_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 114)
#define CHIP_CLK_ROOT_WRCLK_ID              CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 115) /* ?? */
#define CHIP_CLK_ROOT_IPP_DO1_ID            CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 116) /* ?? */
#define CHIP_CLK_ROOT_IPP_DO2_ID            CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 117) /* ?? */
#define CHIP_CLK_ROOT_HDMI_FDCC_TST_ID      CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 118)
#define CHIP_CLK_ROOT_HDMI_REF_266M_ID      CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 120)
#define CHIP_CLK_ROOT_USDHC3_ID             CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 121)
#define CHIP_CLK_ROOT_MEDIA_CAM1_PIX_ID     CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 122)
#define CHIP_CLK_ROOT_MEDIA_MIPI_PHY1_REF_ID CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 123)
#define CHIP_CLK_ROOT_MEDIA_DISP1_PIX_ID    CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 124)
#define CHIP_CLK_ROOT_MEDIA_CAM2_PIX_ID     CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 125)
#define CHIP_CLK_ROOT_MEDIA_LDB_ID          CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 126)
#define CHIP_CLK_ROOT_MEDIA_MIPI_TEST_BYTE_ID CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 130)
#define CHIP_CLK_ROOT_ECSPI3_ID             CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 131)
#define CHIP_CLK_ROOT_PDM_ID                CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 132)
#define CHIP_CLK_ROOT_VPU_VC8000E_ID        CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 133)
#define CHIP_CLK_ROOT_SAI7_ID               CHIP_CLK_ID_ROOT(CHIP_CLK_SLICE_PERIPH, 134)



#endif // CHIP_CLK_DEFS_H
